unit IcoStayU;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, StdCtrls;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
  { Delphi 2 (compiler version 9) has a bug in that the main }
  { form will minimise on startup like all other Delphi 2 }
  { forms - above the task bar, and not _in_ the task bar }
  { These $ifdefs sort it out }
{$ifdef Ver90}
    procedure FormRestore(Sender: TObject);
{$endif}
    procedure WMQueryOpen(var Msg: TWMQueryOpen);
      message wm_QueryOpen;
    procedure WMNCCreate(var Msg: TWMNCCreate);
      message wm_NCCreate;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{$ifdef Ver90}
procedure TForm1.FormRestore(Sender: TObject);
begin
  Perform(wm_SysCommand, sc_Restore, 0);
  Application.OnRestore := nil;
end;
{$endif}

procedure TForm1.WMQueryOpen(var Msg: TWMQueryOpen);
begin
  Msg.Result := 0;
end;

procedure TForm1.WMNCCreate(var Msg: TWMNCCreate);
var
  SysMenu: HMenu;
begin
  inherited;
  { Delphi 1 generally shows the Application window }
  { when iconised. However if the app starts with the main }
  { form minimised then the icon is that of the main form. }
  { It seems that Delphi 2 and 3+ make things more consistent }
  { by using the Application window regardless. Therefore, }
  { some conditional compilation is required }
  SysMenu := GetSystemMenu(
    {$ifndef Windows}Application.{$endif}Handle, False);
  { Get rid of irrelevant system menu entries }
  DeleteMenu(SysMenu, sc_Size,  mf_ByCommand);
  DeleteMenu(SysMenu, sc_Move,  mf_ByCommand);
  DeleteMenu(SysMenu, sc_Minimize,  mf_ByCommand);
  DeleteMenu(SysMenu, sc_Maximize, mf_ByCommand);
  DeleteMenu(SysMenu, sc_Restore,  mf_ByCommand);
  { Get rid of the separator item that remains }
  DeleteMenu(SysMenu, 0, mf_ByPosition);
  { Refresh the system menu }
  DrawMenuBar(Handle);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
{$ifdef Ver90}
  if WindowState = wsMinimized then
  begin
    Application.ShowMainForm := False;
    Application.OnRestore := FormRestore;
    Application.Minimize;
  end;
{$endif}
end;

end.

