//
//  Values are 32 bit values layed out as follows:
//
//   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
//   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
//  +---+-+-+-----------------------+-------------------------------+
//  |Sev|C|R|     Facility          |               Code            |
//  +---+-+-+-----------------------+-------------------------------+
//
//  where
//
//      Sev - is the severity code
//
//          00 - Success
//          01 - Informational
//          10 - Warning
//          11 - Error
//
//      C - is the Customer code flag
//
//      R - is a reserved bit
//
//      Facility - is the facility code
//
//      Code - is the facility's status code
//
//
// Define the facility codes
//


//
// Define the severity codes
//


//
// MessageId: DEMO1_SERVICE_STARTED
//
// MessageText:
//
//  The service started successfully.
//
#define DEMO1_SERVICE_STARTED            0x40000001L

//
// MessageId: DEMO1_SERVICE_PAUSED
//
// MessageText:
//
//  The service was paused.
//
#define DEMO1_SERVICE_PAUSED             0x80000002L

//
// MessageId: DEMO1_SERVICE_CONTINUED
//
// MessageText:
//
//  The service was resumed after being paused for %1 milliseconds.
//
#define DEMO1_SERVICE_CONTINUED          0x40000003L

//
// MessageId: DEMO1_SERVICE_FAILED
//
// MessageText:
//
//  The service failed to start.
//
#define DEMO1_SERVICE_FAILED             0xC0000004L

//
// MessageId: DEMO1_SERVICE_ENDED
//
// MessageText:
//
//  The service ended successfully.
//
#define DEMO1_SERVICE_ENDED              0x40000005L

//
// MessageId: DEMO1_SERVICE_INTERROGATED
//
// MessageText:
//
//  The service status was interrogated.
//
#define DEMO1_SERVICE_INTERROGATED       0x40000006L

//
// MessageId: DEMO1_SERVICE_CODE_INVALID
//
// MessageText:
//
//  The service handler received an unexpected code of '%1'.
//
#define DEMO1_SERVICE_CODE_INVALID       0xC0000007L

//
// MessageId: DEMO1_SERVICE_UPDATE_STATUS_FAILED
//
// MessageText:
//
//  The call to update SCM with current status failed. Last error code was %1.
//
#define DEMO1_SERVICE_UPDATE_STATUS_FAILED 0xC0000008L

//
// MessageId: DEMO1_SERVICE_REGHANDLER_FAILED
//
// MessageText:
//
//  The call to register the service handler failed with %1.
//
#define DEMO1_SERVICE_REGHANDLER_FAILED  0xC0000009L

//
// MessageId: DEMO1_SERVICE_STARTDISPATCHER_FAILED
//
// MessageText:
//
//  The call to start the service displatcher failed with %1.
//
#define DEMO1_SERVICE_STARTDISPATCHER_FAILED 0xC000000AL

//
// MessageId: DEMO1_SERVICE_STARTUP_PARM_INVALID
//
// MessageText:
//
//  The service startup parameter '%1' is invalid. Will use 1 second delay.
//
#define DEMO1_SERVICE_STARTUP_PARM_INVALID 0xC000000BL

