unit dmData;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DB, DBTables;

type
  TdmDataModule = class(TDataModule)
    dbDemo: TDatabase;
    qryCreditIssue: TQuery;
    spCreditNew: TStoredProc;
    qryCreditsOutByCustomer: TQuery;
    qryPaymentMethodsGet: TQuery;
    qryCreditsOutByCustomerAMOUNT: TFloatField;
    qryCreditsOutByCustomerISSUEDATETIME: TDateTimeField;
    qryCreditsOutByCustomerBALANCEDUE: TFloatField;
    qryCreditsOutByCustomerCREDITNO: TIntegerField;
    spPaymentSave: TStoredProc;
    qryPaymentCreditSave: TQuery;
    qryPaymentAllocSave: TQuery;
    spPaymentCreditSave: TStoredProc;
    procedure dmDataModuleCreate(Sender: TObject);
    procedure dmDataModuleDestroy(Sender: TObject);
  private
  public
    PaymentMethodsList: TStringList;
  end;

var
  dmDataModule: TdmDataModule;

implementation

{$R *.DFM}

uses
  uBase;

procedure TdmDataModule.dmDataModuleCreate(Sender: TObject);
var
  Code: PChar;
begin
  PaymentMethodsList := TStringList.Create;

  with qryPaymentMethodsGet do begin
    Open;
    try
      while not Eof do begin
        Code := StrAlloc(Length(FieldByName('PayMethodCode').AsString));
        StrPCopy(Code, FieldByName('PayMethodCode').AsString);
        PaymentMethodsList.AddObject(FieldByName('PayMethodName').AsString, TObject(Code));
        Next;
      end;
    finally
      Close;
    end;
  end;
end;

procedure TdmDataModule.dmDataModuleDestroy(Sender: TObject);
var
  I: Integer;
begin
  if Assigned(PaymentMethodsList) then
    with PaymentMethodsList do begin
      for I := 0 to Count - 1 do
        StrDispose(PChar(Objects[I]));
      Free;
    end;
end;

end.
